<script setup lang="ts">
import { usePartieStore } from '@/stores/partie'
import * as partieService from '@/services/partie'
import { ref, type Ref } from 'vue'
import router from '@/router'
import ErrorDisplay from '@/components/ErrorDisplay.vue'

/*
quand on charge cette vue, c'est pour indiquer le code de partie à rejoindre. Une fois validé, on est redirigé vers la vue de la partie, qui 
s'occupe de déterminer quelles actions prendre
*/

const partieStore = usePartieStore()

const codePartie = ref('')
const loading = ref(false)
const errorMessage: Ref<Error | null> = ref(null)

const submitForm = async () => {
  try {
    // Active l'indicateur de chargement
    loading.value = true
    errorMessage.value = null

    const partie = await partieService.getByCodePartie(codePartie.value)
    partieStore.codePartie = partie.codePartie

    // Réinitialiser les champs du formulaire
    codePartie.value = ''

    router.push('/partie')
  } catch (error) {
    console.error(error)
    if (!(error instanceof Error)) {
      console.error(error)
    } else {
      errorMessage.value = error
    }
  }

  loading.value = false
}
</script>

<template>
  <div class="min-h-full min-w-full flex justify-center items-stretch flex-grow">
    <div class="max-w-md w-full flex flex-col justify-center">
      <div>
        <h2 class="mt-6 text-center text-3xl leading-9 font-extrabold text-gray-900">
          Connexion à une partie
        </h2>
      </div>
      <form class="mt-8 mr-2 ml-2 sm:mr-0 sm:ml-0" @submit.prevent="submitForm">
        <div class="rounded-md flex flex-col gap-2">
          <div>
            <input
              v-model="codePartie"
              aria-label="Code de la partie"
              name="codePartie"
              type="text"
              required
              class="relative w-full input input-bordered"
              placeholder="XXXXXX"
            />
          </div>
        </div>

        <ErrorDisplay :login-error="errorMessage" />

        <div class="mt-6">
          <button
            type="submit"
            class="group relative w-full btn btn-primary justify-center"
            :disabled="loading"
          >
            Connexion
          </button>
        </div>
      </form>
    </div>
  </div>
</template>
